
BKPOINT	; come here after breakpoint has been detected in user program
	; recover registers after breakpoint
	LD	(LLOC),HL		; save HL
	PUSH	AF
	POP	HL
	LD	(FLOC),HL		; save AF
	POP	HL
	LD	(PLLOC),HL		; save PC+1
	LD	HL,0
	ADD	HL,SP
	LD	(SLLOC),HL		; save SP
	LD	SP,STK			; load monitor STACK
	LD	(CLOC),BC		; save BC
	LD	(ELOC),DE		; save DE
	LD	(XLLOC),IX		; save IX
	LD	(YLLOC),IY		; save IY
	EXX
	LD	(LPLOC),HL		; save HL'
	LD	(EPLOC),DE		; save DE'
	LD	(CPLOC),BC		; save BC'
	EX	AF,AF'
	PUSH	AF
	POP	HL
	LD	(FPLOC),HL		; save AF'
	DB	0EDH,057H		; LD	  A,I
	LD	(ILOC),A		; save I
	DB	0EDH,05FH		; LD	  A,R
	LD	(RLOC),A		; save R
	LD	HL,(PLLOC)		; get PC+1
	DEC	HL
	LD	(PLLOC),HL		; save PC
	LD	IX,IXBAS		; monitor needs	IXBAS
	CALL	FXBP			; fix the breakpoints
BPOI20
	CALL	DCPUR			; show the registers
	JP	CMDLOOP			; get next command


FXBP	; clear	breakpoints
	LD	HL,(BPMNS)		; get BP magic # from RAM
	LD	DE,BPMN			; get expected value
	CALL	COMP			; see if same
	JR	Z,FXBP10		; jump if so
DUMPBP	LD	HL,0			; else HL gets 0
	LD	(BPMNS),HL		; to wipe out storage
	LD	HL,S0+IXBAS		; pt to S0
	RES	BP00,(HL)		; clear flag
	RES	BP10,(HL)		; clear flag
	RET
FXBP10	LD	HL,S0+IXBAS		; point	to S0
	BIT	BP00,(HL)		; test for 1st bkpoint
	JR	Z,FXBP20		; jump if none
	LD	DE,(BPAD0)		; get BP address
	LD	A,(BPOC0)		; get opcode
	LD	(DE),A			; update
	RES	BP00,(HL)		; mark clear
FXBP20	BIT	BP10,(HL)		; test for 2nd bkpoint
	JR	Z,FXBP30		; jump if none
	LD	DE,(BPAD1)		; get BP address
	LD	A,(BPOC1)		; get opcode
	LD	(DE),A			; update
	RES	BP10,(HL)		; mark clear
FXBP30	RET


TN1	; advance the PC by Tx
	LD	HL,(PLLOC)
	INC	HL
	JP	SETGO
TN2	LD	HL,(PLLOC)
	INC	HL
	INC	HL
	JP	SETGO
TN3	LD	HL,(PLLOC)
	INC	HL
	INC	HL
	INC	HL
	JP	SETGO
TN4	LD	HL,(PLLOC)
	INC	HL
	INC	HL
	INC	HL
	INC	HL
	JP	SETGO

TJP	; jump,	get destination	following opcode
	LD	HL,(PLLOC)
	INC	HL
	CALL	HLATHL
	JP	SETGO

JPTEST	; if C set then	conditional test will take place
	JR	C,TJP			; will do a jump
	JR	TN3			; else advance 3

TJPNZ	CALL	FNZ
	JR	JPTEST
TJPZ	CALL	FZ
	JR	JPTEST
TJPNC	CALL	FNC
	JR	JPTEST
TJPC	CALL	FC
	JR	JPTEST
TJPPO	CALL	FPO
	JR	JPTEST
TJPPE	CALL	FPE
	JR	JPTEST
TJPP	CALL	FP
	JR	JPTEST
TJPM	CALL	FM
	JR	JPTEST

TJR	; jump relative, get offset following opcode
	LD	HL,(PLLOC)		; get PC
	INC	HL			; pt to	offset
	LD	E,(HL)			; put to DE
	LD	D,0
	DEC	HL			; restore PC
	LD	A,E
	OR	A
	JP	P,TJR10			; jump if jump forward
	LD	D,0FFH			; load MSB to ff for 2s	comp
TJR10					; addition, else leave 0
	ADD	HL,DE			; add em
	INC	HL			; adjust to next PC
	INC	HL
	JP	SETGO			; that's it

JRTEST	; if CY	== 1, then jump	relative, else advance PC 2
	JR	C,TJR
	JP	TN2

TJRC	CALL	FC
	JR	JRTEST
TJRNC	CALL	FNC
	JR	JRTEST
TJRZ	CALL	FZ
	JR	JRTEST
TJRNZ	CALL	FNZ
	JR	JRTEST

	; jump to values contained in registers
TJPHL	LD	HL,(LLOC)
	JP	SETGO
TJPIX	LD	HL,(XLLOC)
	JP	SETGO
TJPIY	LD	HL,(YLLOC)
	JP	SETGO

TDJNZ	LD	A,(BLOC)		; get B	reg
	CP	1			; test for 1
	JR	NZ,TJR			; if not then jump relative
	JP	TN2			; else fall through

TRET	LD	HL,(SLLOC)
	CALL	HLATHL
	JP	SETGO

RETTEST	; if CY	== 1 then do return, else fall through
	JP	C,TRET			; go RET if CY == 1
	JP	TN1			; else fall through

TRETNZ	CALL	FNZ
	JP	RETTEST
TRETZ	CALL	FZ
	JP	RETTEST
TRETNC	CALL	FNC
	JP	RETTEST
TRETC	CALL	FC
	JP	RETTEST
TRETPO	CALL	FPO
	JP	RETTEST
TRETPE	CALL	FPE
	JP	RETTEST
TRETP	CALL	FP
	JP	RETTEST
TRETM	CALL	FM
	JP	RETTEST

	; for restarts
TRST0	LD	HL,0
	JP	SETGO
TRST1	LD	HL,08H
	JP	SETGO
TRST2	LD	HL,10H
	JP	SETGO
TRST3	LD	HL,18H
	JP	SETGO
TRST4	LD	HL,20H
	JP	SETGO
TRST5	LD	HL,28H
	JP	SETGO
TRST6	LD	HL,30H
	JP	SETGO
TRST7	LD	HL,38H
	JP	SETGO

SETGO	; set PC and go	to user	program
	LD	(ARGV0),HL		; save the next	PC location
	JP	GO20			; load regs and	goto user program

FZ	; test for zero	flag set
	LD	A,(FLOC)
	AND	40H
	CALL	NZSETC
	RET
FNZ	; test for zero	flag clear
	CALL	FZ
	CCF
	RET
FC	; test for carry flag set
	LD	A,(FLOC)
	AND	1
	CALL	NZSETC
	RET
FNC	; test for carry flag clear
	CALL	FC
	CCF
	RET
FPE	; test for parity even
	LD	A,(FLOC)
	AND	4H
	CALL	NZSETC
	RET
FPO	; test for parity odd
	CALL	FPE
	CCF
	RET
FM	; test for sign	flag set minus
	LD	A,(FLOC)
	AND	80H
	CALL	NZSETC
	RET
FP	; test for sign	flag set positive
	CALL	FM
	CCF
	RET

TDD	; DD instruction handler
	LD	HL,(PLLOC)
	INC	HL
	LD	A,(HL)
	CP	0E9H
	JR	NZ,TDD10
	LD	HL,(XLLOC)
	JP	SETGO
TDD10	; do 4s then 3s and rest must be 2s
	CP	21H
	JP	Z,TN4		; 21 is 4
	CP	22H
	JP	Z,TN4		; 22 is 4
	CP	2AH
	JP	Z,TN4		; 2A is 4
	CP	36H
	JP	Z,TN4		; 36 is 4
	CP	0CBH
	JP	Z,TN4		; CBs are 4
	; now do 3s
	CP	34H		; 4 is 3
	JP	Z,TN3
	CP	35H		; 5 is 3
	JP	Z,TN3
	AND	0F0H		; look only at MSnibble
	CP	040H		; 4 is 3
	JP	Z,TN3
	CP	050H		; 5 is 3
	JP	Z,TN3
	CP	060H		; 6 is 3
	JP	Z,TN3
	CP	070H		; 7 is 3
	JP	Z,TN3
	CP	080H		; 8 is 3
	JP	Z,TN3
	CP	090H		; 9 is 3
	JP	Z,TN3
	CP	0A0H		; A is 3
	JP	Z,TN3
	CP	0B0H		; B is 3
	JP	Z,TN3
	JP	TN2		; otherwise, it must be 2

TED	; ED instruction handler
	LD	HL,(PLLOC)
	INC	HL
	LD	A,(HL)
	CP	45H
	JR	NZ,TED10
	JP	TRET
TED10	CP	4DH
	JR	NZ,TED20
	JP	TRET
TED20	CP	43H
	JP	Z,TN4
	CP	4BH
	JP	Z,TN4
	CP	53H
	JP	Z,TN4
	CP	5BH
	JP	Z,TN4
	CP	73H
	JP	Z,TN4
	CP	7BH
	JP	Z,TN4
	JP	TN2


TFD	; FD instruction handler
	LD	HL,(PLLOC)
	INC	HL
	LD	A,(HL)
	CP	0E9H
	JR	NZ,TFD10
	LD	HL,(YLLOC)
	JP	SETGO
TFD10	; do 4s then 3s and rest must be 2s
	CP	21H
	JP	Z,TN4		; 21 is 4
	CP	22H
	JP	Z,TN4		; 22 is 4
	CP	2AH
	JP	Z,TN4		; 2A is 4
	CP	36H
	JP	Z,TN4		; 36 is 4
	CP	0CBH
	JP	Z,TN4		; CBs are 4
	; now do 3s
	CP	34H		; 4 is 3
	JP	Z,TN3
	CP	35H		; 5 is 3
	JP	Z,TN3
	AND	0F0H		; look only at MSnibble
	CP	040H		; 4 is 3
	JP	Z,TN3
	CP	050H		; 5 is 3
	JP	Z,TN3
	CP	060H		; 6 is 3
	JP	Z,TN3
	CP	070H		; 7 is 3
	JP	Z,TN3
	CP	080H		; 8 is 3
	JP	Z,TN3
	CP	090H		; 9 is 3
	JP	Z,TN3
	CP	0A0H		; A is 3
	JP	Z,TN3
	CP	0B0H		; B is 3
	JP	Z,TN3
	JP	TN2		; otherwise, it must be 2
