
; BSS Storage -- read write memory

	ORG	BSSBASE		; start	of read/write storage

IXBAS	EQU	*

S0	EQU	*-IXBAS		; state	of the system
	DS	1		; 0 -> BP00
				; 1 -> BP10
				; 2 ->
				; 3 ->
				; 4 ->
				; 5 ->
				; 6 ->
				; 7 ->

S1	EQU	*-IXBAS		; 0 ->
	DS	1		; 1 ->
				; 2 ->
				; 3 ->
				; 4 ->
				; 5 ->
				; 6 ->
				; 7 ->

ARGC	DS	1		; number of arguments
ARGV0	DS	2		; first	arg
ARGV1	DS	2		; second arg
ARGV2	DS	2		; third	arg
ARGV3	DS	2		; fourth arg
ARGVT	EQU	*		; end of argument list

REGBAS	EQU	*		; start	of register storage

FLOC	DS	1		; storage for register F
ALOC	DS	1		; storage for register A
ILOC	DS	1		; storage for register I
CLOC	DS	1		; storage for register C
BLOC	DS	1		; storage for register B
ELOC	DS	1		; storage for register E
DLOC	DS	1		; storage for register D
LLOC	DS	1		; storage for register L
HLOC	DS	1		; storage for register H
XLLOC	DS	1		; storage for register XL
XHLOC	DS	1		; storage for register XH
YLLOC	DS	1		; storage for register YL
YHLOC	DS	1		; storage for register YH
SLLOC	DS	1		; storage for register SL
SHLOC	DS	1		; storage for register SH
PLLOC	DS	1		; storage for register PL
PHLOC	DS	1		; storage for register PH
RLOC	DS	1		; storage for register R
FPLOC	DS	1		; storage for register F'
APLOC	DS	1		; storage for register A'
CPLOC	DS	1		; storage for register C'
BPLOC	DS	1		; storage for register B'
EPLOC	DS	1		; storage for register E'
DPLOC	DS	1		; storage for register D'
LPLOC	DS	1		; storage for register L'
HPLOC	DS	1		; storage for register H'
REGBAST	EQU	*		; end of REGISTERS

; storage for BREAK POINTS
BPMNS	DS	2		; storage for magic # flag
BPOC0	DS	1		; op code for 0
BPAD0	DS	2		; address for 0
BPOC1	DS	1		; op code for 1
BPAD1	DS	2		; address for 1

; misc storage
CKSUM	DS	1		; accumulator for checksum calculations
LSTPORT	DS	1		; last port accessed for input
MISC0	DS	1		; misc storage
MISC1	DS	1		; misc storage
MISC2	DS	1		; misc storage
MISC3	DS	1		; misc storage
FBUF	DS	16		; storage for find command

	ORG	BSSBASE&0FF00H+0F5H
BSSEND	EQU	*		; end of BSS
SLTRAM	DS	1		; scope loop test ram (xF5H)
POVEC	DS	2		; power on vector (xF6)
POVECCK	DS	2		; power on vector compliment (xF8)
NMIVRAM	DS	3		; ram for user NMI vector (xFAH)
INTVRAM	DS	3		; ram for user RST7 vector (xFDH)

