
DEMOCMD	; demo command interpreter
	CALL	GETUCHE			; get a	char and echo
	CP	'E'			; see if ENTER wanted
	JR	NZ,DEMOC10		; jump if not
	JP	DEME			; do the routine
DEMOC10	CP	'I'			; see if INTERACTIVE wanted
	JR	NZ,DEMOC20		; jump if not
	JP	DEMI			; do the routine
DEMOC20	CP	'P'			; see if PRESENTATION wanted
	JR	NZ,DEMOC30		; jump if not
	JP	DEMP			; do the routine
DEMOC30	CP	'V'			; see if DEMO VECTORS wanted
	JR	NZ,DEMOC40		; jump if not
	JP	DEMVTR			; do the routine
DEMOC40	JP	CMDNOP			; else, bad command

DEMVTR	; AO command: show demo vectors
	CALL	CRLF			; output a new line
	LD	HL,DEMVS10		; get string
	CALL	PUTS			; output the string
	LD	HL,ARGV0		; get value to print
	CALL	PHL			; print it
	CALL	CRLF			; output a new line
	LD	HL,DEMVS20		; get string
	CALL	PUTS			; output the string
	LD	HL,DEMI20		; get value to print
	CALL	PHL			; print it
	CALL	CRLF			; output a new line
	LD	HL,DEMVS30		; get string
	CALL	PUTS			; output the string
	LD	HL,DEMP10		; get value to print
	CALL	PHL			; print it
	CALL	CRLF			; output a new line
	LD	HL,DEMVS40		; get string
	CALL	PUTS			; output the string
	LD	HL,RAMSTRT		; get value to print
	CALL	PHL			; print it
	CALL	CRLF			; output a new line
	LD	HL,DEMVS50		; get string
	CALL	PUTS			; output the string
	LD	HL,BSSBASE-RAMSTRT-20	; get value to print
	CALL	PHL			; print it
	CALL	CRLF			; print newline
	CALL	CRLF			; print newline
	RET
DEMVS10	DB	'ARGV0      '		; address for ARGV0
	DB	ANULL			; end of string
DEMVS20	DB	'AI         '		; address for INTERACTIVE func
	DB	ANULL			; end of string
DEMVS30	DB	'AP         '		; address for PRESENTATION func
	DB	ANULL			; end of string
DEMVS40	DB	'RAM START  '		; address for RAMSTART
	DB	ANULL			; end of string
DEMVS50	DB	'RAM LENGTH '		; approx length of RAM available
	DB	ANULL			; end of string

DEMI	; interactive demo output screens
	; use '~' to separate screens
	; ai "addr" "delay" <opt>
	; opt -> b1/b0 == 00, CR
	; opt -> b1/b0 == 01, LF
	; opt -> b1/b0 == 10, CR/LF
	; con==space: next screen
	; con==N: Nth screen
	; the "|" is considered to be a printable escape character
	; enter "||" to have a single "|" appear in the output
	; enter "|x" to have control x (^x) appear in the output (where
	; x is any printable character).  So to get a bell, enter
	; the escape sequence "|G".
	CALL	SPACE1			; space after command
	CALL	CARG			; collect arguments
	LD	A,(ARGC)		; get count
	CP	2			; see if 2
	JR	Z,DEMI10		; jump if OK
	CP	3			; see if 3
	JR	Z,DEMI10		; jump if OK
	JP	ARGERR			; error if not
DEMI10	CALL	CRLF
	CALL	CRLF			; 2 new lines
DEMI20	XOR	A			; clear A
DEMI30	LD	C,A			; save at screen reg
	LD	(ARGV3),A		; and screen memory
	CALL	DGETS			; get ptr to screen, CY=1 if null
	JR	C,DEMI40		; jump if null screen
	CALL	DPUTS			; print it
	CALL	DTIME			; time delay
	JR	C,DEMI30		; jump if char found, screen in A
DEMI40	LD	A,(ARGV3)		; else get last screen used
	INC	A			; pt to next
	AND	7			; only 8 allowed
	JR	DEMI30			; do it again

DPUTS	; display screen, end of screen marked with '~'
	LD	A,(HL)			; get a char
	CP	'~'			; see if end
	RET	Z			; ret if so
	CP	ALF			; see if newline
	JR	NZ,DPUTS30		; not end of line
	LD	A,(ARGV2)		; get option values
	AND	003H			; look only at B1/B0
	CP	0			; see if 0
	JR	NZ,DPUTS10		; jump if not
	LD	A,ACR			; get CR
	CALL	PUTCHAR			; put the character
	JR	DPUTS40			; do another lap
DPUTS10	CP	1			; see if 1
	JR	NZ,DPUTS20		; jump if not
	LD	A,ALF			; get LF
	CALL	PUTCHAR			; put the character
	JR	DPUTS40			; do another lap
DPUTS20	; consider all others to be same as 2
	LD	A,ACR			; get CR
	CALL	PUTCHAR			; put the character
	LD	A,ALF			; get LF
DPUTS30	CALL	CKPESC			; do any printable escape chars
	CALL	PUTCHAR			; put the character
DPUTS40	INC	HL			; inc ptr
	JR	DPUTS			; and loop till done

DGETS	; get ptr to current screen
	LD	HL,(ARGV0)		; get ptr to start of string
DGETS10	LD	A,C			; get screen number
	OR	A			; see if done
	JR	NZ,DGETS20		; jump if not
	LD	A,(HL)			; get first char
	CP	'~'			; see if end of screen
	CALL	NZSETC			; clear CY if so
	CCF				; set CY if so
	RET
DGETS20	LD	A,(HL)			; else get char
	INC	HL			; inc ptr
	CP	'~'			; see if end of screen
	JR	NZ,DGETS20		; jump if not
	DEC	C			; dec screen ctr
	JR	DGETS10			; loop till its zero

DCCHK	; see if valid character has been entered
	CALL	RBRDY			; see if char waiting
	RET	NC			; ret with CY = 0 if not
	CALL	GETCHAR			; else get char
	CP	' '			; see if control
	JP	M,DCCHK20		; jump if so
	CP	' '+1			; see if more than space
	JP	P,DCCHK10		; jump as valid if so
	LD	A,(ARGV3)		; else want nxt scrn NOW!, get it
	INC	A			; inc screen ct
DCCHK10	AND	7			; only 8 allowed
	SCF				; mark char found
	RET				; that's all
DCCHK20	OR	A			; valid char not found, CY = 0
	RET

DTIME	; provide time proportional to ARGV1
	LD	A,(ARGV1)		; get master timer
	LD	B,A			; save in B
DTIME10	LD	HL,21248		; ld secdry tmr for 1 sec delay
DTIME20	CALL	DCCHK			; check for valid character
	RET	C			; done if so
	DEC	HL			; else inc HL
	LD	A,H			; and see
	OR	L			; if it is
	JR	NZ,DTIME20		; zero, loop if not
	DJNZ	DTIME10			; dec master timer until done
	OR	A			; CY = 0 to show normal timeout
	RET

DEME	; enter text until ^D; ARGV0 is ptr to sp; ARGV1 is !0 for no echo
	CALL	SPACE1			; space after command
	CALL	CARG			; collect arguments
	LD	A,(ARGC)		; get count
	CP	1			; see if 1
	JR	Z,DEME10		; that's OK
	CP	2			; or if 1
	JR	Z,DEME10		; that's OK
	JP	ARGERR			; error if not
DEME10	CALL	CRLF			; print a newline
	LD	HL,(ARGV0)		; get ptr to start of text
	LD	DE,ARGV3		; DE is pointer to local variable
	XOR	A			; clear A
	LD	(DE),A			; no chars yet
DEME20	CALL	GETCHAR			; get a char
	LD	(HL),0			; save null in case end of string
	CP	'D'&1FH			; see if ^D
	RET	Z			; return if so
	OR	A			; see if NULL
	JR	Z,DEME20		; skip if NULL
	CP	ACR			; see if CR
	JR	NZ,DEME30		; jump if not
	CALL	EECHO			; echo the char
	LD	A,ALF			; convert to LF
	LD	(HL),A			; save it
	INC	HL			; inc ptr
	CALL	EECHO			; echo the char
	EX	DE,HL			; swap DE HL
	LD	(HL),0			; new line, no chars yet
	EX	DE,HL			; swap back
	JR	DEME20			; do till done
DEME30	CP	ALF			; see if LF
	JR	Z,DEME20		; ignore it
	CP	'H'&1FH			; see if backspace
	JR	Z,DEME40		; jump if so
	CP	7FH			; see if delete
	JR	Z,DEME40		; jump if so
	LD	(HL),A			; normal char, save it
	INC	HL			; inc ptr
	CALL	EECHO			; echo
	EX	DE,HL			; swap DE HL
	INC	(HL)			; char added, inc the ctr
	EX	DE,HL			; swap back
	JR	DEME20			; loop till done
DEME40	EX	DE,HL			; swap DE HL
	LD	A,(HL)			; get char ctr
	OR	A			; see if zero
	EX	DE,HL			; swap back
	JR	Z,DEME20		; skip erase if at start of line
	DEC	HL			; dec the pointer
	LD	A,'H'&1FH		; get backspace
	CALL	EECHO			; back it up
	LD	A,' '			; get space
	CALL	EECHO			; wipe out character
	LD	A,'H'&1FH		; get backspace
	CALL	EECHO			; back it up again
	EX	DE,HL			; swap DE HL
	DEC	(HL)			; dec the char ctr
	EX	DE,HL			; swap back
	JR	DEME20			; loop till done

EECHO	; echo only real characters
	LD	C,A			; save char in C
	LD	A,(ARGV1)		; echo echo value
	OR	A			; set flags
	LD	A,C			; restore char
	RET	NZ			; no echo if ARGV1 !0 in lsbyte
	CP	ALF			; see if ALF
	JR	EECHO10			; jump if so
	CP	ACR			; see if ACR
	JR	EECHO10			; jump if so
	CP	'H'&1FH			; see if backspace
	JR	EECHO10			; jump if so
	CP	'G'&1FH			; see if bell
	JR	EECHO10			; jump if so
	OR	A			; set flags
	RET	M			; return if not seven bit ascii
	CP	' '			; see if less than space
	RET	M			; return if so
EECHO10	CALL	PUTCHAR			; char OK, echo it
	RET

;EECHO	; echo character in A if lsbyte of ARGV1 is not zero
;	LD	C,A			; save char in C
;	LD	A,(ARGV1)		; get option
;	OR	A			; set flags
;	LD	A,C			; restore char into A
;	CALL	NZ,PUTCHAR		; echo the character
;	RET

DEMP	; ap "addr" <opt>
	; outputs presentation text starting at "addr"
	; "opt" contains option information
	; opt -> b1/b0 == 00, CR
	; opt -> b1/b0 == 01, LF
	; opt -> b1/b0 == 10, CR/LF
	; opt -> b2 == 0, output text without regard to echo
	; opt -> b2 == 1, output next line 2 S after no echo
	; console input is ignored.
	; delays can be inserted inline with the text by
	; a string of "~Dnnnn" where ~ is the tilde character
	; D is uppercase D (0x44) and nnn is a decimal (base 10) number
	; that represents the delay.  "nnnn" is in units of (about) 100mS
	; the "|" is considered to be a printable escape character
	; enter "||" to have a single "|" appear in the output
	; enter "|x" to have control x (^x) appear in the output (where
	; x is any printable character).  So to get a bell, enter
	; the escape sequence "|G".
	CALL	SPACE1			; space after command
	CALL	CARG			; collect arguments
	LD	A,(ARGC)		; get number of arguments
	CP	1			; see if 1
	JR	Z,DEMP10		; that's OK
	CP	2			; or if 2
	JR	Z,DEMP10		; that's OK
	JP	ARGERR			; error if not
DEMP10	LD	HL,(ARGV0)		; pt to string
	CALL	DEMSTR			; print it once
	JR	DEMP10			; and do it again

DEMSTR	; output a line at a time with desired end of line stuff
	CALL	DEMLN			; output a line
	OR	A			; set flags on last char
	RET	Z			; return if null
	LD	A,(ARGV1)		; get option values
	AND	003H			; look only at B1/B0
	CP	0			; see if 0
	JR	NZ,DEMS10		; jump if not
	LD	A,ACR			; get CR
	CALL	PUTCHAR			; put the character
	JR	DEMS30			; done with end of line
DEMS10	CP	1			; see if 1
	JR	NZ,DEMS20		; jump if not
	LD	A,ALF			; get LF
	CALL	PUTCHAR			; put the character
	JR	DEMS30			; done with end of line
DEMS20	; consider all others to be same as 2
	LD	A,ACR			; get CR
	CALL	PUTCHAR			; put the character
	LD	A,ALF			; get LF
	CALL	PUTCHAR			; done with end of line
DEMS30	LD	A,(ARGV1)		; get status stuff
	BIT	2,A			; want to wait for echo to stop?
	JR	Z,DEMSTR		; jump if not
DEMST40	LD	DE,20000		; set DE with time delay
DEMST50	DEC	DE			; dec the count
	LD	A,D			; get D
	OR	E			; and or with E
	JR	Z,DEMSTR		; start nxt ln if DE==0 (timed-out)
	CALL	RBRDY			; else see if rx buffer ready
	JR	NC,DEMST50		; loop until time-out or char found
	CALL	GETCHAR			; dump the char
	JR	DEMST40			; restart timer

DEMLN	; output a line of demo
	CALL	CTSRDY			; see if CTS is ready
	JR	NC,DEMLN		; loop if not
	LD	A,(HL)			; get a char
	OR	A			; set flags
	RET	Z			; ret if end of string
	INC	HL			; pt to next char
	CP	ALF			; see if end of line
	RET	Z			; end if so	
	CP	'~'			; see if special
	JR	NZ,DEMLN10		; jump if so
	LD	A,(HL)			; get cmd char
	INC	HL			; and pt to next
	CALL	MAPUC			; map to upper case
	CP	'D'			; see if D for delay
	JR	NZ,DEMLN		; bad if not
	CALL	STOINT			; conv following str to int in DE
	CALL	DELAY			; delay that amount of seconds
	JR	DEMLN			; and continue
DEMLN10	CALL	CKPESC			; check for printable escape char
	CALL	PUTCHAR			; put what it returns
	JP	DEMLN			; and do it again
	
CKPESC	; check for printable escape stuff
	CP	'|'			: see if escape char
	RET	NZ			; return char if not
	LD	A,(HL)			; else get char after escape
	INC	HL			; pt to next
	CP	'|'			; see if escape
	RET	Z			; return char if so
	AND	01FH			; else look only at 5 lsbits
	RET				; and return it

STOINT	; string to int, value in DE
	LD	IY,0			; value is zero so far
STOIN10	LD	A,(HL)			; get a char
	CALL	MAPUC			; map to upper case
	CALL	CHARINT			; convert to 4 bits int
	PUSH	IY			; copy ACC
	POP	DE			; into DE
	RET	C			; ret if bad
	INC	HL			; else, pt to next char
	LD	B,10-1			; get number of times to add
STOIN20	ADD	IY,DE			; add to it again
	DJNZ	STOIN20			; loop as required
	LD	E,A			; put value into E
	LD	D,0			; zero out D
	ADD	IY,DE			; add the new value
	JR	STOIN10			; loop till not HX

