
; low memory code

	ORG	CODEBAS			; start	of program

START
NUL	NOP
	NOP
	DI				; disable those	pesty interrups!
	JP	START10			; scope loop tests

	; io vectors
GETCHAR	JP	VGET			; get a	char
GETCE	JP	VGETE			; get a	char with echo
PUTCHAR	JP	VPUT			; put a	char
RBRDY	JP	VRBRDY			; C=1 if rx buf	ready
TBRDY	JP	VTBRDY			; C=1 if tx buf	ready
INTSP	JP	VINTSP			; init serial port
CTSRDY	JP	VCTSRDY			; C=1 if clear to send
INTPP	JP	VINTPP			; init parallel port

	IF	ROM			; do only if code in ROM & ZAMTOR
	ERRPL	*-CODEBAS-030H-1	; error if past 30H
	DS	CODEBAS+030H-*		; space	to Bkt Pt restart location
	ERRNZ	*-CODEBAS-030H		; error	if not 30H from	the bottom
	JP	BKPOINT			; jump to BK PT.  don't return here
	ERRPL	*-CODEBAS-038H-1	; error if past 38H
	DS	CODEBAS+038H-*		; space	to int vector location
	ERRNZ	*-CODEBAS-038H		; error	if not 38H from	the bottom
	JP	INTVRAM			; jump to int.  don't return here
	ENDIF

SIGNON	; print a signon message
	LD	HL,MSGSGON		; point	to msg
	CALL	PUTS			; put it
	CALL	BSUM			; calculate byte sum of code space
	CALL	PHL			; print HL value
	CALL	CRLF			; newlines
	CALL	CRLF
	RET

	IF	ROM
	ERRPL	*-CODEBAS-66H-1		; error if past 66H
	DS	CODEBAS+066H-*		; space	to NMI vector location
	ERRNZ	*-CODEBAS-066H		; error	if not 66H from	the bottom
	JP	NMIVRAM			; jump to int.  don't return here
	ENDIF

	IF	ROM
	ERRPL	*-CODEBAS-69H-1		; error if past 69H
	DS	CODEBAS+069H-*		; space to scope loop address
	ERRNZ	*-CODEBAS-069H		; error	if not 69H from	the bottom
	ENDIF

MSGCPRT	DB	ACR,ALF			; ascii	copyright string
	DB	'COPYRIGHT (C) 1985 --1990 PAUL NEWLAND, P.E.'
	DB	ACR,ALF,ANULL

START10	LD	SP,STK			; load the stack

START14	CALL	INTPP			; init the parallel ports
	CALL	INTSP			; init the serial port
	CALL	POVT			; pwr on vector test (may not ret)
	CALL	FXBP			; fix any outstanding break-points
	LD	HL,BSSBASE		; zero the BSS
	LD	B,BSSEND-BSSBASE	; get number of	mem locations
START15	LD	(HL),0			; zero one
	INC	HL			; inc ptr
	DJNZ	START15			; loop till done
	LD	HL,USRSTK		; load user stack
	LD	(SLLOC),HL		; load user stack
	LD	IX,IXBAS		; IX points to IXBASE

	IF	DEV			; load vector if development
	LD	A,0C3H			; get jump value
	LD	(INTLOC),A		; set up jump
	LD	HL,BKPOINT		; get for breakpoints
	LD	(INTLOC+1),HL		; put at jump location
	ENDIF

	CALL	SIGNON			; sign on
CMDLOOP	LD	SP,STK			; reload stack for error routine
	CALL	DOCOMMD			; do a command
	JR	CMDLOOP

DOCOMMD	CALL	PROMPT			; put the prompt
	CALL	GETUCHE			; get a	char and echo
	SUB	'A'
	JP	M,DOCOM10		; end if < 'A'
	CP	'Z'-'A'+1		; map 'A' to 0
	JP	NC,DOCOM10		; end if > 'Z'
	ADD	A,A			; double index
	LD	E,A			; save in E
	LD	D,0			; zero D
	LD	HL,CMDTBL		; pt to	command	table
	ADD	HL,DE			; add em
	CALL	HLATHL			; get ptr from table
	JP	(HL)			; do the function
DOCOM10	; bad input
	CALL	CRLF			; print	a newline if no	function
	RET

CMDTBL	; command table
	DW	DEMOCMD			; A - demo command interpreter
	DW	BLAST			; B - blast (bi, bo, bf, bt)
	DW	CHECK			; C - Check BEGIN END = + +1
	DW	DISPLAY			; D - D[isplay]	START STOP
	DW	CMDNOP			; E - nop
	DW	FIND			; F - F[ind] B0 B1 B2 ... B15
	DW	GO			; G - G[o]<ADDR> <BP1> <BP2>
	DW	HELP			; H - H[elp] print help message
	DW	INPUT			; I - I[nput] ADDRESS
	DW	JAM			; J - J[am] START END VALUE
	DW	CMDNOP			; K - nop
	DW	LSTACK			; L - L[ist user stack values]
	DW	MOVE			; M - M[ove] BEGIN END TO
	DW	NEXT			; N - N[ext instruction]
	DW	OUTPUT			; O - O[utput] ADDR VALUE
	DW	CMDNOP			; P - nop
	DW	CMDNOP			; Q - nop
	DW	RX			; R - R[eceive Intel code] <OFFSET>
	DW	SUBST			; S - S[ubstitute] ADDR
	DW	TEST			; T - T[est memory] START STOP
	DW	UPPOW			; U - U[p-power-vector] VALUE
	DW	VERIFY			; V - V[erify] BEGIN END TO
	DW	CMDNOP			; W - nop
	DW	XAM			; X - [e]X[amine regs] <<'>REG>
	DW	HEXMATH			; Y - Y[hexmath] ARG0 ARG1 =+ -
	DW	ZNEXT			; Z - Z[next inst] don't brk calls

CMDNOP	; command nop
	LD	HL,NOPMSG
	CALL	PUTS
	RET

HELP	; this command fills the screen with help information
	LD	HL,HELPMSG
	CALL	PUTS
	RET
